#include <algorithm>
#include <cstdio>
#include <iostream>
#include <vector>
using namespace std;
#pragma warning (disable : 4996)

vector<vector<pair<int, int> > > vertexes;
vector<int> used;

void DFS(int num, int L, vector<vector<pair<int, int> > > v)
{
	if (v[num].size() == 0)
	{
		DFS(num + 1, L, v);
		return;
	}
	used[num] = 1;
	for (size_t i = 0; i < vertexes[num].size(); i++)
		if (!used[vertexes[num][i].first] && vertexes[num][i].second >= L)
			DFS(vertexes[num][i].first, L, v);
}

bool isEmpty(vector<pair<int, int> > a)
{
	return a.size() == 0;
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	int n, m, k;
	cin >> n >> m >> k;
	vertexes = vector<vector<pair<int, int> > >(n);
	int curV[3], maxE = 0;
	for (int i = 0; i < m; i++)
	{
		cin >> curV[0] >> curV[1] >> curV[2];
		curV[0]--, curV[1]--;
		vertexes[curV[0]].push_back(make_pair(curV[1], curV[2]));
		vertexes[curV[1]].push_back(make_pair(curV[0], curV[2]));
		maxE = max(maxE, curV[2]);
	}

	int curL = 1, maxL = 1;
	while (curL <= maxE)
	{
		int maxCount = 0;
		vector<vector<pair<int, int> > > curVer = vertexes;
		used = vector<int>(n, 0);
		while (!all_of(curVer.begin(), curVer.end(), isEmpty))
		{
			DFS(0, curL, curVer);
			maxCount = max(maxCount, count(used.begin(), used.end(), 1));
			for (size_t i = 0; i < curVer.size(); i++)
				if (used[i])
				{
					curVer[i].clear();
					used[i] = 0;
				}
		}
		if (maxCount < k)
			break;
		curL++;
	}
	
	cout << curL - 1;
}