#include <algorithm>
#include <cstdio>
#include <iostream>
#include <vector>
using namespace std;
#pragma warning (disable : 4996)

vector<pair<int, int> > *vertexes;
int *used, n;

void DFS(int num, int L, int usedValue)
{
	if (num == n) return;
	used[num] = usedValue;
	for (size_t i = 0; i < vertexes[num].size(); i++)
		if (!used[vertexes[num][i].first] && vertexes[num][i].second >= L)
			DFS(vertexes[num][i].first, L, usedValue);
}

bool isNotZero(int a)
{
	return a != 0;
}

bool checkL(int L, int k)
{
	int maxL = 1, *lastUsed = used;
	int maxCount = 0, usedValue = 1;
	fill(used, used + n, 0);
	while (!all_of(used, used + n, isNotZero))
	{
		lastUsed = find(lastUsed, used + n, 0);
		DFS(lastUsed - used, L, usedValue);
		maxCount = max(maxCount, (int)count(used, used + n, usedValue));
		usedValue++;
	}
	return maxCount > k;
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	int m, k;
	cin >> n >> m >> k;
	vertexes = new vector<pair<int, int> >[n];
	used = new int[n];
	int curV[3], maxE = 0;
	for (int i = 0; i < m; i++)
	{
		cin >> curV[0] >> curV[1] >> curV[2];
		curV[0]--, curV[1]--;
		vertexes[curV[0]].push_back(make_pair(curV[1], curV[2]));
		vertexes[curV[1]].push_back(make_pair(curV[0], curV[2]));
		maxE = max(maxE, curV[2]);
	}

	int left = 1, right = 1000000000, cur = (left + right + 1) / 2;
	while (left < cur || cur < right)
	{
		if (checkL(cur, k)) left = cur;
		else right = cur - 1;
		cur = (left + right + 1) / 2;
	}
	
	cout << cur;
}